package codechicken.microblock.handler

import codechicken.lib.packet.PacketCustom.IClientPacketHandler
import codechicken.lib.packet.PacketCustom.IServerPacketHandler
import codechicken.lib.packet.PacketCustom
import net.minecraft.client.network.NetHandlerPlayClient
import net.minecraft.network.NetHandlerPlayServer
import net.minecraft.client.Minecraft
import codechicken.microblock.MicroMaterialRegistry
import net.minecraft.network.play.server.S40PacketDisconnect
//import net.minecraft.network.NetServerHandler
import net.minecraft.entity.player.EntityPlayerMP
import net.minecraft.util.ChatComponentText;

class MicroblockPH
{
    val registryChannel = "ForgeMicroblock"//Must use the 250 system for ID registry as the NetworkMod idMap hasn't been properly initialized from the server yet.
}

object MicroblockCPH extends MicroblockPH with IClientPacketHandler
{
    def handlePacket(packet:PacketCustom, netHandler:NetHandlerPlayClient, mc:Minecraft)
    {
        packet.getType match
        {
            case 1 => handleMaterialRegistration(packet, netHandler)
        }
    }
    
    def handleMaterialRegistration(packet:PacketCustom, netHandler:NetHandlerPlayClient)
    {
        val missing = MicroMaterialRegistry.readIDMap(packet)
        if(!missing.isEmpty)
            netHandler.handleDisconnect(new S40PacketDisconnect(new ChatComponentText("The following microblocks are not installed on this client: "+missing.mkString(", "))))
    }
}

object MicroblockSPH extends MicroblockPH with IServerPacketHandler
{
    def handlePacket(packet:PacketCustom, netHandler:NetHandlerPlayServer, sender:EntityPlayerMP){}
}